open Wiki
module D = Graph.Path.Dijkstra (WikiGraph) (Weight)

let page g v =
  try
    let s = IntMap.find v g.labels in
    "https://simple.wikipedia.org/wiki/" ^ s
  with
  | Not_found -> "<INCONNU>"

let display_path graph l len =
  Printf.printf "Distance: %d\n" len;
  match l with
  | [] -> ()
  | (v, w) :: ll ->
      Printf.printf "%s\n%s\n" (page graph v) (page graph w);
      List.iter (fun (_, w) -> Printf.printf "%s\n" (page graph w)) ll

let main () =
  let () = Printf.printf "Construction du graphe\n%!" in
  let wiki = WikiGraph.build "simple-pages.txt" "simple-links.txt" in
  let () =
    Printf.printf "Ok, nombre de sommets: %d\n" (WikiGraph.nb_vertex wiki)
  in
  let alanis_morissette = 14 in
  (* cf le fichier simple-pages.txt *)
  let snowboard = 63644 in

  (* cf le fichier simple-pages.txt *)
  let l, len = D.shortest_path wiki snowboard alanis_morissette in
  display_path wiki l len

let () = main ()
